addHook("MobjThinker", function(m)
	if stoppedclock == true
	and gamemap == 462
		if m.state == S_BUMPER
		or m.state == S_BUMPERHIT
			A_PlaySound(m, sfx_pop, 0)
			m.state = S_XPLD1
		end
	end
end, MT_BUMPER)
addHook("PlayerSpawn", function(p)
	if gamemap == 468
	and ultimatemode == false
	and leveltime < 35
		if p.powers[3] ~= 512
		and p.playerstate == 0
			P_SwitchShield(p, 257)
		elseif p.powers[3] == 512
		and p.playerstate == 0
			P_SwitchShield(p, 769)
		end
	end
end)
addHook("MapLoad", function(gamemap)
	if gamemap == 468
		states[S_SSPK1].sprite = SPR_SHCK
		states[S_SSPK2].sprite = SPR_SHCK
		states[S_SSPK3].sprite = SPR_SHCK
		states[S_SSPK4].sprite = SPR_SHCK
		states[S_SSPK5].sprite = SPR_SHCK
	else
		states[S_SSPK1].sprite = SPR_SSPK
		states[S_SSPK2].sprite = SPR_SSPK
		states[S_SSPK3].sprite = SPR_SSPK
		states[S_SSPK4].sprite = SPR_SSPK
		states[S_SSPK5].sprite = SPR_SSPK
	end
end)
addHook("MobjSpawn", function(m)
	if gamemap == 478
		m.health = 16
		m.info.damage = 11
	else
		m.info.damage = 3
	end
end, MT_EGGMOBILE3)
addHook("MobjThinker", function(m)
	if gamemap == 468
		if P_RandomRange(1, 255) == 1
			S_StartSound(m, sfx_cdfm34)
			P_SpawnMobjFromMobj(m, 0, 0, 0, MT_SUPERSPARK)
		end
	end
end, MT_TUBEWAYPOINT)
addHook("MobjFuse", function(m)
	if gamemap == 481
		P_SpawnMobj(m.x, m.y, m.x, MT_BUMBLEBORE)
	end
end, MT_CYBRAKDEMON_FLAMEREST)
addHook("PlayerSpawn", function(p)
	if gamemap == 462//GFZ3
	and leveltime >= 35
		P_SetOrigin(p.mo, 2848*FRACUNIT, 2912*FRACUNIT, 800*FRACUNIT)
	end
	if gamemap == 465//THZ3
	and leveltime >= 35
		P_SetOrigin(p.mo, 0, 0, 800*FRACUNIT)
	end
	if gamemap == 468//DSZ3
	and leveltime >= 35
		P_SetOrigin(p.mo, 1696*FRACUNIT, 128*FRACUNIT, 800*FRACUNIT)
	end
	if gamemap == 471//CEZ3
	and leveltime >= 35
		P_SetOrigin(p.mo, 1760*FRACUNIT, 2304*FRACUNIT, 800*FRACUNIT)
	end
	if gamemap == 474//ACZ3
	and leveltime >= 35
		P_SetOrigin(p.mo, 0, 0, 800*FRACUNIT)
	end
	if gamemap == 478//ERZ3
	and leveltime >= 35
		P_SetOrigin(p.mo, 448*FRACUNIT, 6016*FRACUNIT, 800*FRACUNIT)
	end
	if gamemap == 480//BCZ2
	and leveltime >= 35
		P_SetOrigin(p.mo, 0, 0, 800*FRACUNIT)
	end
	if gamemap == 481//BCZ3
	and leveltime >= 35
		P_SetOrigin(p.mo, 5600*FRACUNIT, 3072*FRACUNIT, 800*FRACUNIT)
	end
end)//this hook prevents you from respawning during this mod's boss fights in netgames, and from spawning mid-way through the boss fight, by sticking you into a reset chamber