addHook("MobjSpawn", function(m)
	m.dietimer = 0
end, MT_DETON)
addHook("MobjThinker", function(m)
	if m.state ~= S_DETON1
		m.dietimer = m.dietimer+1
	else m.dietimer = 0
	end
	if m.dietimer >= 210
		P_DamageMobj(m, m, m, 1, 128)
	end
end, MT_DETON)
addHook("ShouldDamage", function(t, i, s, d, dt)
	if i.type == MT_CACOFIRE
		return false
	end
end, MT_POPUPTURRET)
addHook("MobjSpawn", function(m)
	m.shootwait = 0
end, MT_JETJAW)
addHook("MobjThinker", function(m)
	m.shootwait = m.shootwait+1
	if m.shootwait >= 175
	and m.target
	and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 400*FRACUNIT
		P_SpawnMissile(m, m.target, MT_TORPEDO2)
		S_StartSound(m, sfx_rlaunc)
		A_FaceTarget(m)
		m.shootwait = 0
	end
end, MT_JETJAW)
addHook("MobjSpawn", function(m)
	P_SpawnMobjFromMobj(m, 64, 0, 0, MT_SPIKEBALL)
	A_FindTracer(m, MT_SPIKEBALL, 0)
	m.tracer.target = m
	m.tracer.state = S_SPIKEBALL1A
	P_SetOrigin(m.tracer, (m.x - 128), (m.y - 128), (m.z - 128))
	m.tracer = nil
end, MT_BIGMINE)
addHook("MobjSpawn", function(m)
	m.shootwait = 0
end, MT_ROBOHOOD)
addHook("MobjThinker", function(m)
	m.shootwait = m.shootwait+1
	if m.shootwait >= 28
	and m.target
	and (m.eflags & MFE_ONGROUND)
	and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 400*FRACUNIT
		P_SpawnMissile(m, m.target, MT_ARROW)
		S_StartSound(m, sfx_s3ka0)
		A_FaceTarget(m)
		m.shootwait = 0
	end
end, MT_ROBOHOOD)
addHook("MobjSpawn", function(m)
	m.mad = 0
	P_SpawnMobjFromMobj(m, 64, 0, 0, MT_SPIKEBALL)
	A_FindTracer(m, MT_SPIKEBALL, 0)
	m.tracer.target = m
	m.tracer.state = S_SPIKEBALL1A
	P_SetOrigin(m.tracer, (m.x - 128), (m.y - 128), (m.z - 128))
	m.tracer = nil
end, MT_EGGGUARD)
addHook("MobjThinker", function(m)
	if m.state == S_EGGGUARD_MAD1
		m.mad = 1
	end
	if m.mad == 1
		m.destscale = (FRACUNIT/2)*3
	end
	if m.mad == 1
	and m.state == S_EGGGUARD_STND
		m.destscale = FRACUNIT
		m.mad = 0
	end
end, MT_EGGGUARD)
addHook("MobjDeath", function(m)
		S_StartSound(m, sfx_s3k4e)
end, MT_EGGGUARD)
addHook("MobjSpawn", function(m)
	m.shootwait = 0
end, MT_CANARIVORE)
addHook("MobjThinker", function(m)
	m.shootwait = m.shootwait+1
	if m.shootwait >= 175
	and m.state == S_CANARIVORE_GAS2
		P_SpawnMobjFromMobj(m, 0, 0, 0, MT_DRAGONMINE)
		m.shootwait = 0
	end
end, MT_CANARIVORE)
addHook("MobjSpawn", function(m)
	m.shootwait = 0
end, MT_MINUS)
addHook("MobjThinker", function(m)
	if m.target
	and m.state == S_MINUS_AERIAL4
		m.shootwait = m.shootwait+1
	end
	if m.shootwait >= 6
		P_SpawnMissile(m, m.target, MT_ROCKET)
		m.shootwait = 0
	end
	if m.state == S_MINUS_POPUP
		m.shootwait = 0
	end
end, MT_MINUS)
addHook("MobjSpawn", function(m)
	P_SpawnMobjFromMobj(m, 64, 0, 0, MT_SPIKEBALL)
	A_FindTracer(m, MT_SPIKEBALL, 0)
	m.tracer.target = m
	m.tracer.angle = ANGLE_180
	m.tracer.state = S_SPIKEBALL1A
	P_SetOrigin(m.tracer, (m.x - 128), (m.y - 128), (m.z - 128))
	m.tracer = nil
	P_SpawnMobjFromMobj(m, -64, 0, 0, MT_SPIKEBALL)
	A_FindTarget(m, MT_SPIKEBALL, 0)
	m.target.target = m
	m.target.state = S_SPIKEBALL1A
	m.target = nil
end, MT_VULTURE)
addHook("MobjSpawn", function(m)
	m.shootwait = 210
	m.shootwait2 = 0
end, MT_UNIDUS)
addHook("MobjThinker", function(m)
	m.shootwait = m.shootwait+1
	if m.shootwait >= 245
	and m.target
		m.shootwait2 = 5
		m.shootwait = 0
	end
	if m.shootwait2 > 0
	and m.target
	and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 600*FRACUNIT
	and P_RandomRange(1, 20) == 1
		P_SpawnMissile(m, m.target, MT_ROCKET)
		m.shootwait2 = m.shootwait2-1
	end
end, MT_UNIDUS)
addHook("MobjThinker", function(m)
	if m.target
	and m.state == S_PYREFLY_BURN
	and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 800*FRACUNIT
		P_SpawnMissile(m, m.target, MT_PYREFLY_FIRE)
		S_StartSound(m, sfx_fire)
	end
end, MT_PYREFLY)
addHook("TouchSpecial", function(s, t)
    if t.player.nightstime
    and t.player.nightstime > 10*TICRATE
        t.player.nightstime = t.player.nightstime-(10*TICRATE)
    elseif t.player.nightstime
    and t.player.nightstime <=10*TICRATE
    and t.player.nightstime > 1
        t.player.nightstime = 1
    end
end, MT_PYREFLY_FIRE)
addHook("MobjThinker", function(m)
	if m.cusval >= 11
		m.cusval = 10
	end
end, MT_PTERABYTE)//makes it impossible to mash out of pterabytes, though I hear that this might not apply to the android port
addHook("MobjSpawn", function(m)
	m.shootwait = 0
end, MT_JETTGUNNER)
addHook("MobjThinker", function(m)
	if (m.flags2 & MF2_AMBUSH)
		m.shootwait = m.shootwait+1
		if m.shootwait >= 70
		and m.target
		and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 700*FRACUNIT
			P_SpawnMissile(m, m.target, MT_JETTBULLET)
			S_StartSound(m, sfx_s3k4d)
			m.shootwait = 0
		end
	end
end, MT_JETTGUNNER)
addHook("MobjSpawn", function(m)
	m.shootwait = 0
end, MT_JETTBOMBER)
addHook("MobjThinker", function(m)
	if (m.flags2 & MF2_AMBUSH)
		m.shootwait = m.shootwait+1
		if m.shootwait >= 35
			A_TrapShot(m, MT_MINE, 270)
			S_StartSound(m, sfx_s3k51)
			m.shootwait = 0
		end
	end
end, MT_JETTBOMBER)
addHook("ShouldDamage", function(t, i, s, d, dt)
	if i.type == MT_DRAGONMINE
		return false
	end
end, MT_JETTBOMBER)
addHook("MobjSpawn", function(m)
	m.shootwait = 0
	m.shootwait2 = 0
end, MT_PENGUINATOR)
addHook("MobjThinker", function(m)
	m.shootwait = m.shootwait+1
	if m.shootwait >= 35
	and m.state == S_PENGUINATOR_SLIDE5
	and m.target
	and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 1000*FRACUNIT
		m.shootwait2 = 5
		m.shootwait = 0
	end
	if m.shootwait2 > 0
	and m.target
	and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 1000*FRACUNIT
	and P_RandomRange(1, 8) == 1
		P_SpawnMissile(m, m.target, MT_ROCKET)
		m.shootwait2 = m.shootwait2-1
	end
end, MT_PENGUINATOR)
addHook("MobjSpawn", function(m)
	m.shootwait = 0
end, MT_CRAWLACOMMANDER)
addHook("MobjThinker", function(m)
	m.shootwait = m.shootwait+1
	if m.shootwait >= 105
	and m.target
	and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 1000*FRACUNIT
		P_SpawnMissile(m, m.target, MT_ROCKET)
		m.shootwait = 0
	end
end, MT_CRAWLACOMMANDER)
addHook("MobjSpawn", function(m)
	m.shootwait = 0
end, MT_HANGSTER)
addHook("MobjThinker", function(m)
	m.shootwait = m.shootwait+1
	if m.shootwait >= 70
	and m.target
	and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 1000*FRACUNIT
		P_SpawnMissile(m, m.target, MT_ROCKET)
		m.shootwait = 0
	end
end, MT_HANGSTER)
addHook("MobjSpawn", function(m)
	m.shootwait = 0
end, MT_POINTY)
addHook("MobjThinker", function(m)
	m.shootwait = m.shootwait+1
	if m.shootwait >= 70
	and m.target
	and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 1000*FRACUNIT
		P_SpawnMissile(m, m.target, MT_ROCKET)
		m.shootwait = 0
	end
end, MT_POINTY)
addHook("ShouldDamage", function(t, i, s, d, dt)
	return false
end, MT_SPINBOBERT)
addHook("ShouldDamage", function(t, i, s, d, dt)
	if i.type == MT_CACOFIRE
		return false
	end
end, MT_CACOLANTERN)
addHook("MapLoad", function(m)
	if gamemap == 474//ACZ3
	or gamemap == 481//BCZ3
		states[S_BUMBLEBORE_DIE].nextstate = S_XPLD1
	else
		states[S_BUMBLEBORE_DIE].nextstate = S_TNTBARREL_EXPLA
	end
end)
addHook("ShouldDamage", function(t, i, s, d, dt)
	if gamemap == 481
	and i == nil
		return false
	end
end, MT_BUMBLEBORE)//prevents bumblebores from killing themselves on the laser FoF that appears some seconds in since block enemies linedefs don't check vertical positions
addHook("MobjSpawn", function(m)
	P_SpawnMobjFromMobj(m, 64, 0, 0, MT_SPIKEBALL)
	A_FindTracer(m, MT_SPIKEBALL, 0)
	m.tracer.target = m
	m.tracer.angle = ANGLE_180
	m.tracer.state = S_SPIKEBALL1A
	P_SetOrigin(m.tracer, (m.x - 128), (m.y - 128), (m.z - 128))
	m.tracer = nil
	P_SpawnMobjFromMobj(m, -64, 0, 0, MT_SPIKEBALL)
	A_FindTarget(m, MT_SPIKEBALL, 0)
	m.target.target = m
	m.target.state = S_SPIKEBALL1A
	m.target = nil
end, MT_HIVEELEMENTAL)
addHook("MobjSpawn", function(m)
	P_SpawnMobjFromMobj(m, 64, 0, 0, MT_SPIKEBALL)
	A_FindTracer(m, MT_SPIKEBALL, 0)
	m.tracer.target = m
	m.tracer.angle = ANGLE_180
	m.tracer.state = S_SPIKEBALL1A
	P_SetOrigin(m.tracer, (m.x - 128), (m.y - 128), (m.z - 128))
	m.tracer = nil
	P_SpawnMobjFromMobj(m, -64, 0, 0, MT_SPIKEBALL)
	A_FindTarget(m, MT_SPIKEBALL, 0)
	m.target.target = m
	m.target.state = S_SPIKEBALL1A
	m.target = nil
end, MT_BUGGLE)
addHook("MobjSpawn", function(m)
	m.shootwait = 0
	m.color = SKINCOLOR_WHITE
end, MT_GOOMBA)
addHook("MobjThinker", function(m)
	m.colorized = (m.health == 2)
	m.shootwait = m.shootwait+1
	if m.shootwait >= 70
	and m.health == 2
	and m.target
	and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 400*FRACUNIT
		A_HoodFire(m, MT_FIREBALL)
		S_StartSound(m, sfx_mario7)
		m.shootwait = 0
	end
end, MT_GOOMBA)
addHook("MobjSpawn", function(m)
	m.shootwait = 0
	m.color = SKINCOLOR_WHITE
end, MT_BLUEGOOMBA)
addHook("MobjThinker", function(m)
	m.colorized = (m.health == 2)
	m.shootwait = m.shootwait+1
	if m.shootwait >= 70
	and m.health == 2
	and m.target
	and P_AproxDistance(m.target.x-m.x, m.target.y-m.y) <= 400*FRACUNIT
		A_HoodFire(m, MT_FIREBALL)
		S_StartSound(m, sfx_mario7)
		m.shootwait = 0
	end
end, MT_BLUEGOOMBA)
addHook("TouchSpecial", function(s, t)
    if t.player.nightstime
    and t.player.nightstime > 10*TICRATE
        t.player.nightstime = t.player.nightstime-(10*TICRATE)
    elseif t.player.nightstime
    and t.player.nightstime <=10*TICRATE
    and t.player.nightstime > 1
        t.player.nightstime = 1
    end
end, MT_SHLEEP)